;******************************************************************************
;* TMS320C6x C/C++ Codegen                                          PC v5.1.0 *
;* Date/Time created: Fri Aug 08 16:28:02 2008                                *
;******************************************************************************
	.compiler_opts --endian=little --mem_model:code=near --mem_model:data=far_aggregates --quiet --silicon_version=6416 --symdebug:none 

;******************************************************************************
;* GLOBAL FILE PARAMETERS                                                     *
;*                                                                            *
;*   Architecture      : TMS320C64xx                                          *
;*   Optimization      : Enabled at level 3                                   *
;*   Optimizing for    : Speed                                                *
;*                       Based on options: -o3, no -ms                        *
;*   Endian            : Little                                               *
;*   Interrupt Thrshld : Disabled                                             *
;*   Data Access Model : Far Aggregate Data                                   *
;*   Pipelining        : Enabled                                              *
;*   Speculate Loads   : Disabled                                             *
;*   Memory Aliases    : Presume are aliases (pessimistic)                    *
;*   Debug Info        : No Debug Info                                        *
;*                                                                            *
;******************************************************************************

	.asg	A15, FP
	.asg	B14, DP
	.asg	B15, SP
	.global	$bss

	.global	_timer_done
	.bss	_timer_done,4,4
	.global	_read_done
	.bss	_read_done,4,4
	.global	_ext_int
	.bss	_ext_int,4,4
	.global	_imageptrout
	.bss	_imageptrout,4,4
	.global	_wr_num_sec
	.bss	_wr_num_sec,4,4
	.global	_rd_num_sec
	.bss	_rd_num_sec,4,4
;	c:\pf\CCStudio_v3.1\C6000\cgtools\bin\opt6x.exe --gen_opt_info=2 c:\DOCUME~1\kloub\LOCALS~1\Temp\TI5762 c:\DOCUME~1\kloub\LOCALS~1\Temp\TI5764 --opt_info_filename=main.nfo 
	.sect	".text"
	.global	_main

;******************************************************************************
;* FUNCTION NAME: _main                                                       *
;*                                                                            *
;*   Regs Modified     : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,B0,B1,B2,B3,B4,B5,B6,  *
;*                           B7,B8,B9,B10,SP,A16,A17,A18,A19,A20,A21,A22,A23, *
;*                           A24,A25,A26,A27,A28,A29,A30,A31,B16,B17,B18,B19, *
;*                           B20,B21,B22,B23,B24,B25,B26,B27,B28,B29,B30,B31  *
;*   Regs Used         : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,B0,B1,B2,B3,B4,B5,B6,  *
;*                           B7,B8,B9,B10,B13,DP,SP,A16,A17,A18,A19,A20,A21,  *
;*                           A22,A23,A24,A25,A26,A27,A28,A29,A30,A31,B16,B17, *
;*                           B18,B19,B20,B21,B22,B23,B24,B25,B26,B27,B28,B29, *
;*                           B30,B31                                          *
;*   Local Frame Size  : 0 Args + 0 Auto + 8 Save = 8 byte                    *
;******************************************************************************
_main:
;** --------------------------------------------------------------------------*
;** 43	-----------------------    *(unsigned *)0x1800000u = 160u;
;** 44	-----------------------    *(unsigned *)0x1800008u = 208u;
;** 45	-----------------------    *(unsigned *)0x180001cu = 768u;
;** 46	-----------------------    *(unsigned *)0x1800020u = 345384u;
;** 47	-----------------------    *(unsigned *)0x1800018u = 0x53116000u;
;** 54	-----------------------    *(volatile unsigned *)0x200u = 65536u;
;** 56	-----------------------    *(volatile unsigned *)0x204u = 0x80000000u;
;** 57	-----------------------    *(volatile unsigned *)0x214u = K$34 = 0u;
;** 160	-----------------------    CSL6416_LIB_();  // [4]
;** 176	-----------------------    _CSL_init((union $$fake4 *)0xffffffffu);  // [4]
;** 176	-----------------------    MemportInit();  // [4]
;**  	-----------------------    K$55 = 4096;
;**  	-----------------------    K$42 = 1u;
;**  	-----------------------    K$61 = 0xfffffffeu;
;**  	-----------------------    K$67 = 1024u;
;**  	-----------------------    K$71 = 0x68000030u;
;**  	-----------------------    K$75 = 4u;
;**  	-----------------------    K$79 = 0x41180001u;
;**  	-----------------------    K$93 = 65520u;
;**  	-----------------------    K$113 = (-4096);
;**  	-----------------------    K$53 = (volatile int *)0x10000u;
;**  	-----------------------    K$47 = (volatile unsigned *)0x80000000u;
;**  	-----------------------    #pragma LOOP_FLAGS(4096u)

           MVKL    .S2     0x180001c,B6      ; |45| 
||         MVKL    .S1     0x1800008,A3      ; |44| 

           MVK     .S2     208,B8            ; |44| 
||         MVK     .S1     160,A8            ; |43| 

           MVK     .S1     768,A7            ; |45| 
||         MVKL    .S2     0x1800020,B5      ; |46| 
||         ZERO    .L2     B7                ; |43| 

           MVKH    .S2     0x1800000,B7      ; |43| 
||         MVKL    .S1     0x54528,A5        ; |46| 

           MVKL    .S2     0x1800018,B4      ; |47| 
||         MVKH    .S1     0x1800008,A3      ; |44| 
||         STW     .D2T2   B10,*SP--(8)      ; |31| 

           STW     .D1T2   B8,*A3            ; |44| 
||         STW     .D2T1   A8,*B7            ; |43| 
||         MVKH    .S2     0x180001c,B6      ; |45| 
||         MVKL    .S1     0x53116000,A4     ; |47| 

           STW     .D2T1   A7,*B6            ; |45| 
||         MVKH    .S1     0x54528,A5        ; |46| 
||         MVKH    .S2     0x1800020,B5      ; |46| 

           STW     .D2T1   A5,*B5            ; |46| 
||         MVKH    .S1     0x53116000,A4     ; |47| 
||         MVKH    .S2     0x1800018,B4      ; |47| 

           MVKL    .S2     _CSL6416_LIB_,B4  ; |160| 
||         STW     .D2T1   A4,*B4            ; |47| 

           MVKH    .S2     _CSL6416_LIB_,B4  ; |160| 
           CALL    .S2     B4                ; |160| 

           ZERO    .L2     B7                ; |54| 
||         MVK     .S1     512,A6            ; |54| 

           ZERO    .L1     A5                ; |56| 
||         MVK     .S1     516,A3            ; |56| 
||         MVKH    .S2     0x10000,B7        ; |54| 

           STW     .D1T2   B7,*A6            ; |54| 
||         MVKH    .S1     0x80000000,A5     ; |56| 

           MVK     .S1     532,A3            ; |57| 
||         STW     .D1T1   A5,*A3            ; |56| 
||         STW     .D2T2   B13,*+SP(4)       ; |31| 
||         ZERO    .L2     B10               ; |57| 

           ADDKPC  .S2     RL0,B3,0          ; |160| 
||         STW     .D1T2   B10,*A3           ; |57| 

RL0:       ; CALL OCCURS {_CSL6416_LIB_}     ; |160| 
;** --------------------------------------------------------------------------*
           MVKL    .S1     __CSL_init,A3     ; |176| 
           MVKH    .S1     __CSL_init,A3     ; |176| 
           MVK     .L1     0xffffffff,A4     ; |176| 
           CALL    .S2X    A3                ; |176| 
           ADDKPC  .S2     RL1,B3,4          ; |176| 
RL1:       ; CALL OCCURS {__CSL_init}        ; |176| 
           CALL    .S1     _MemportInit      ; |176| 
           ADDKPC  .S2     RL2,B3,4          ; |176| 
RL2:       ; CALL OCCURS {_MemportInit}      ; |176| 
;** --------------------------------------------------------------------------*
           MVKL    .S2     0x68000030,B7
           MVK     .S2     0x400,B21

           MVKH    .S2     0x68000030,B7
||         MVKL    .S1     0x41180001,A8
||         ZERO    .L2     B4

           SET     .S2     B4,0x4,0xf,B9
||         MVK     .S1     0x1000,A18
||         ZERO    .L2     B8

           MVKH    .S2     0x10000,B8
||         MVK     .L2     0x1,B18
||         MVK     .S1     0xfffff000,A17
||         ZERO    .D2     B6

           MVKH    .S2     0x80000000,B6
||         MVKH    .S1     0x41180001,A8
||         MVK     .L2     0xfffffffe,B19
||         MVK     .D2     0x4,B20

;** --------------------------------------------------------------------------*
           MVK     .S2     524,B4            ; |65| 
;** --------------------------------------------------------------------------*
;**   BEGIN LOOP L1
;** --------------------------------------------------------------------------*
L1:    
;**	-----------------------g2:
;** 65	-----------------------    *(volatile unsigned *)0x20cu = K$34;
;** 67	-----------------------    if ( *(volatile unsigned *)0x20cu ) goto g5;
;**  	-----------------------    #pragma LOOP_FLAGS(4096u)

           STW     .D2T2   B10,*B4           ; |65| 
||         MVK     .S1     524,A3            ; |67| 
||         MVK     .S2     532,B4            ; |67| (P) <0,0> 
||         MV      .L2     B18,B5

           LDW     .D1T1   *A3,A0            ; |67| 
           NOP             4

           MV      .L1     A0,A1             ; guard predicate rewrite
|| [ A0]   B       .S1     L5                ; |67| 
|| [!A0]   STW     .D2T2   B5,*B4            ; |67| (P) <0,1>  ^ 

   [!A1]   MVK     .L2     0x1,B0
|| [!A0]   LDW     .D1T1   *A3,A0            ; |67| (P) <0,2>  ^ 

           NOP             4
           ; BRANCHCC OCCURS {L5}            ; |67| 
;**	-----------------------g4:
;** 67	-----------------------    *(volatile unsigned *)0x214u = K$42;
;** 67	-----------------------    if ( !*(volatile unsigned *)0x20cu ) goto g4;
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 67
;*      Loop opening brace source line   : 67
;*      Loop closing brace source line   : 67
;*      Known Minimum Trip Count         : 1                    
;*      Known Max Trip Count Factor      : 1
;*      Loop Carried Dependency Bound(^) : 7
;*      Unpartitioned Resource Bound     : 2
;*      Partitioned Resource Bound(*)    : 2
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        0     
;*      .S units                     2*       1     
;*      .D units                     1        1     
;*      .M units                     0        0     
;*      .X cross paths               0        0     
;*      .T address paths             1        1     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          0        1     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             1        1     
;*      Bound(.L .S .D .LS .LSD)     1        1     
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 7  Schedule found with 2 iterations in parallel
;*
;*      Register Usage Table:
;*          +-----------------------------------------------------------------+
;*          |AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB|
;*          |00000000001111111111222222222233|00000000001111111111222222222233|
;*          |01234567890123456789012345678901|01234567890123456789012345678901|
;*          |--------------------------------+--------------------------------|
;*       0: |*                               |*    *                          |
;*       1: |*  *                            |*   **                          |
;*       2: |*  *                            |*    *                          |
;*       3: |*                               |*    *                          |
;*       4: |*                               |*    *                          |
;*       5: |*                               |*    *                          |
;*       6: |*                               |*    *                          |
;*          +-----------------------------------------------------------------+
;*
;*      Done
;*
;*      Loop is interruptible
;*      Collapsed epilog stages     : 1
;*      Prolog not removed
;*      Collapsed prolog stages     : 0
;*
;*      Minimum required memory pad : 0 bytes
;*
;*      Minimum safe trip count     : 1
;*----------------------------------------------------------------------------*
;*       SETUP CODE
;*
;*                  MVK             0x1,B0
;*                  ZERO            A0
;*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C249:
;*   0              MVK     .S2     532,B4            ; |67| 
;*     ||           MVK     .S1     524,A3            ; |67| 
;*   1      [ B0]   STW     .D2T2   B5,*B4            ; |67|  ^ 
;*   2      [ B0]   LDW     .D1T1   *A3,A0            ; |67|  ^ 
;*   3              NOP             4
;*   7      [ A0]   ZERO    .L2     B0                ; |67|  ^ 
;*   8      [ B0]   B       .S1     C249              ; |67| 
;*   9              NOP             5
;*  14              ; BRANCHCC OCCURS {C249}          ; |67| 
;*----------------------------------------------------------------------------*
L2:    ; PIPED LOOP PROLOG
;** --------------------------------------------------------------------------*
L3:    ; PIPED LOOP KERNEL

   [ A0]   ZERO    .L2     B0                ; |67| <0,7>  ^ 
||         MVK     .S1     524,A3            ; |67| <1,0> 
||         MVK     .S2     532,B4            ; |67| <1,0> 

   [ B0]   B       .S1     L3                ; |67| <0,8> 
|| [ B0]   STW     .D2T2   B5,*B4            ; |67| <1,1>  ^ 

   [ B0]   LDW     .D1T1   *A3,A0            ; |67| <1,2>  ^ 
           NOP             4
;** --------------------------------------------------------------------------*
L4:    ; PIPED LOOP EPILOG
;** --------------------------------------------------------------------------*
           MV      .L2     B5,B18
;** --------------------------------------------------------------------------*
L5:    
;**	-----------------------g5:
;** 69	-----------------------    *(volatile unsigned *)0x214u = K$34;
;** 70	-----------------------    *(volatile unsigned *)0x218u = K$34;
;** 71	-----------------------    *(volatile unsigned *)0x21cu = K$34;
;** 76	-----------------------    imageptrout = K$47;
;** 79	-----------------------    imagelen = *(volatile unsigned *)0x208u;
;** 74	-----------------------    imageptrin = K$53;
;** 82	-----------------------    if ( imagelen < K$55 ) goto g19;

           MVK     .S1     532,A3            ; |69| 
||         MVK     .S2     536,B4            ; |70| 
||         MV      .L2     B8,B22            ; |74| 

           STW     .D1T2   B10,*A3           ; |69| 
||         MVK     .S2     540,B31           ; |71| 
||         MVK     .S1     520,A31           ; |79| 

           STW     .D2T2   B10,*B4           ; |70| 
           STW     .D2T2   B10,*B31          ; |71| 
           STW     .D2T2   B6,*+DP(_imageptrout) ; |76| 
           LDW     .D1T1   *A31,A6           ; |79| 
           NOP             4
           CMPLT   .L1     A6,A18,A0         ; |82| 

   [ A0]   BNOP    .S1     L19,1             ; |82| 
|| [ A0]   ZERO    .L1     A9                ; |82| 
|| [!A0]   ZERO    .L2     B31               ; |95| 
|| [!A0]   MVKL    .S2     0x68000020,B4     ; |84| 

   [!A0]   MVKH    .S2     0x68000020,B4     ; |84| 

   [!A0]   STW     .D2T2   B10,*B4           ; |84| 
|| [!A0]   SHR     .S2X    A6,12,B2

   [!A0]   STW     .D2T2   B31,*+DP(_read_done) ; |95| 
   [!A0]   MV      .L1X    B2,A9             ; |82| 
           ; BRANCHCC OCCURS {L19}           ; |82| 
;**  	-----------------------    L$1 = imagelen>>12;
;** 82	-----------------------    i_part = L$1;
;**  	-----------------------    #pragma MUST_ITERATE(1, 524287, 1)
;**  	-----------------------    #pragma LOOP_FLAGS(4096u)
;** --------------------------------------------------------------------------*
;**   BEGIN LOOP L6
;** --------------------------------------------------------------------------*
L6:    
;**	-----------------------g7:
;** 84	-----------------------    *(volatile unsigned *)0x68000020u = K$34;
;** 95	-----------------------    read_done = 0u;
;** 354	-----------------------    gie = CSR&1u;  // [0]
;** 355	-----------------------    a$4 = CSR&K$61;  // [0]
;** 355	-----------------------    CSR = a$4;  // [0]
;** 844	-----------------------    *(volatile unsigned *)0x2000004u = (unsigned)imageptrin;  // [5]
;** 845	-----------------------    *(volatile unsigned *)0x2000008u = K$67;  // [5]
;** 846	-----------------------    *(volatile unsigned *)0x200000cu = K$71;  // [5]
;** 847	-----------------------    *(volatile unsigned *)0x2000010u = K$75;  // [5]
;** 848	-----------------------    *(volatile unsigned *)0x2000020u = K$79;  // [5]
;** 360	-----------------------    a$5 = CSR&K$61|gie&1u;  // [1]
;** 360	-----------------------    CSR = a$5;  // [1]
;** 104	-----------------------    if ( read_done ) goto g10;
;**  	-----------------------    #pragma LOOP_FLAGS(4096u)
           MVC     .S2     CSR,B4            ; |354| 

           AND     .L2     1,B4,B17          ; |354| 
||         MVC     .S2     CSR,B4            ; |355| 

           AND     .L2     B19,B4,B4         ; |355| 
           MVC     .S2     B4,CSR            ; |355| 

           MVKL    .S2     0x2000004,B4      ; |844| 
||         MVKL    .S1     0x2000020,A3      ; |848| 

           MVKH    .S2     0x2000004,B4      ; |844| 
||         MVKH    .S1     0x2000020,A3      ; |848| 

           MVKL    .S2     0x2000008,B16     ; |845| 
||         STW     .D2T2   B22,*B4           ; |844| 

           MVKH    .S2     0x2000008,B16     ; |845| 

           MVKL    .S2     0x200000c,B5      ; |846| 
||         STW     .D2T2   B21,*B16          ; |845| 

           MVKH    .S2     0x200000c,B5      ; |846| 

           MVKL    .S2     0x2000010,B30     ; |847| 
||         STW     .D2T2   B7,*B5            ; |846| 

           MVKH    .S2     0x2000010,B30     ; |847| 
           STW     .D2T2   B20,*B30          ; |847| 

           STW     .D1T1   A8,*A3            ; |848| 
||         MVC     .S2     CSR,B4            ; |360| 

           AND     .L2     1,B17,B5          ; |360| 
||         AND     .S2     B19,B4,B4         ; |360| 

           OR      .L2     B5,B4,B4          ; |360| 
           MVC     .S2     B4,CSR            ; |360| 
           LDW     .D2T2   *+DP(_read_done),B0 ; |104| 
           NOP             4

   [ B0]   BNOP    .S1     L10,4             ; |104| 
|| [!B0]   MVK     .L2     0x1,B0
|| [!B0]   LDW     .D2T2   *+DP(_read_done),B1 ; |104| (P) <0,0>  ^ 

   [ B1]   ZERO    .L2     B0                ; |104| (P) <0,5>  ^ 
           ; BRANCHCC OCCURS {L10}           ; |104| 
;**	-----------------------g9:
;** 104	-----------------------    if ( !read_done ) goto g9;
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 104
;*      Loop closing brace source line   : 104
;*      Known Minimum Trip Count         : 1                    
;*      Known Max Trip Count Factor      : 1
;*      Loop Carried Dependency Bound(^) : 6
;*      Unpartitioned Resource Bound     : 1
;*      Partitioned Resource Bound(*)    : 1
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        0     
;*      .S units                     1*       0     
;*      .D units                     0        1*    
;*      .M units                     0        0     
;*      .X cross paths               0        0     
;*      .T address paths             0        1*    
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          0        1     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             1*       0     
;*      Bound(.L .S .D .LS .LSD)     1*       1*    
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 6  Schedule found with 2 iterations in parallel
;*
;*      Register Usage Table:
;*          +-----------------------------------------------------------------+
;*          |AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB|
;*          |00000000001111111111222222222233|00000000001111111111222222222233|
;*          |01234567890123456789012345678901|01234567890123456789012345678901|
;*          |--------------------------------+--------------------------------|
;*       0: |                                |**            *                 |
;*       1: |                                |**            *                 |
;*       2: |                                |**            *                 |
;*       3: |                                |**            *                 |
;*       4: |                                |**            *                 |
;*       5: |                                |**            *                 |
;*          +-----------------------------------------------------------------+
;*
;*      Done
;*
;*      Loop is interruptible
;*      Collapsed epilog stages     : 1
;*      Prolog not removed
;*      Collapsed prolog stages     : 0
;*
;*      Minimum required memory pad : 0 bytes
;*
;*      Minimum safe trip count     : 1
;*----------------------------------------------------------------------------*
;*       SETUP CODE
;*
;*                  MVK             0x1,B0
;*                  ZERO            B1
;*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C214:
;*   0      [ B0]   LDW     .D2T2   *+DP(_read_done),B1 ; |104|  ^ 
;*   1              NOP             4
;*   5      [ B1]   ZERO    .L2     B0                ; |104|  ^ 
;*   6      [ B0]   B       .S1     C214              ; |104| 
;*   7              NOP             5
;*  12              ; BRANCHCC OCCURS {C214}          ; |104| 
;*----------------------------------------------------------------------------*
L7:    ; PIPED LOOP PROLOG
;** --------------------------------------------------------------------------*
L8:    ; PIPED LOOP KERNEL

   [ B0]   BNOP    .S1     L8,4              ; |104| <0,6> 
|| [ B0]   LDW     .D2T2   *+DP(_read_done),B1 ; |104| <1,0>  ^ 

   [ B1]   ZERO    .L2     B0                ; |104| <1,5>  ^ 
;** --------------------------------------------------------------------------*
L9:    ; PIPED LOOP EPILOG
;** --------------------------------------------------------------------------*
L10:    
;**	-----------------------g10:
;** 107	-----------------------    rd_num_sec = 4u;
;** 108	-----------------------    if ( rd_num_sec <= 4u ) goto g12;
;** 111	-----------------------    rd_num_sec = 4u;
;**	-----------------------g12:
;** 114	-----------------------    data_in_sec = 0;
;** 116	-----------------------    if ( !rd_num_sec ) goto g15;

           MVK     .L2     4,B4              ; |107| 
||         MVK     .S2     4,B31             ; |111| 
||         ZERO    .L1     A3                ; |114| 

           STW     .D2T2   B4,*+DP(_rd_num_sec) ; |107| 
           LDW     .D2T2   *+DP(_rd_num_sec),B4 ; |108| 
           NOP             4

           MVK     .S2     0x1,B4            ; |115| 
||         CMPGTU  .L2     B4,4,B0           ; |108| 

   [ B0]   STW     .D2T2   B31,*+DP(_rd_num_sec) ; |111| 

           MV      .L1X    B4,A5
||         LDW     .D2T2   *+DP(_rd_num_sec),B0 ; |116| 

           NOP             4

   [!B0]   BNOP    .S1     L14,3             ; |116| 
|| [ B0]   LDW     .D2T2   *+DP(_rd_num_sec),B4 ; |116| (P) <0,0>  ^ 
|| [ B0]   ZERO    .L2     B5                ; |116| 
|| [ B0]   MV      .L1     A3,A4
|| [ B0]   MVK     .D1     0x1,A0

   [ B0]   ADD     .L2     1,B5,B5           ; |116| (P) <0,4> 
|| [ B0]   OR      .L1     A5,A4,A4          ; |117| (P) <0,5> 

           CMPLTU  .L2     B5,B4,B0          ; |116| (P) <0,5>  ^ 
           ; BRANCHCC OCCURS {L14}           ; |116| 
;** 115	-----------------------    mask = 1;
;** 116	-----------------------    i = 0;
;**  	-----------------------    #pragma LOOP_FLAGS(4096u)
;**	-----------------------g14:
;** 117	-----------------------    data_in_sec |= mask;
;** 118	-----------------------    mask *= 2;
;** 116	-----------------------    if ( (unsigned)(++i) < rd_num_sec ) goto g14;
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 116
;*      Loop opening brace source line   : 116
;*      Loop closing brace source line   : 119
;*      Known Minimum Trip Count         : 1                    
;*      Known Max Trip Count Factor      : 1
;*      Loop Carried Dependency Bound(^) : 7
;*      Unpartitioned Resource Bound     : 2
;*      Partitioned Resource Bound(*)    : 2
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        1     
;*      .S units                     0        1     
;*      .D units                     0        1     
;*      .M units                     0        0     
;*      .X cross paths               0        0     
;*      .T address paths             0        1     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          4        1     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             0        1     
;*      Bound(.L .S .D .LS .LSD)     2*       2*    
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 7  Schedule found with 2 iterations in parallel
;*
;*      Register Usage Table:
;*          +-----------------------------------------------------------------+
;*          |AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB|
;*          |00000000001111111111222222222233|00000000001111111111222222222233|
;*          |01234567890123456789012345678901|01234567890123456789012345678901|
;*          |--------------------------------+--------------------------------|
;*       0: |*  ***                          |*   **        *                 |
;*       1: |*  ***                          |    **        *                 |
;*       2: |*  ***                          |    **        *                 |
;*       3: |*  ***                          |    **        *                 |
;*       4: |*  ***                          |    **        *                 |
;*       5: |*  ***                          |    **        *                 |
;*       6: |*  ***                          |    **        *                 |
;*          +-----------------------------------------------------------------+
;*
;*      Done
;*
;*      Loop is interruptible
;*      Collapsed epilog stages     : 1
;*      Prolog not removed
;*      Collapsed prolog stages     : 0
;*
;*      Minimum required memory pad : 0 bytes
;*
;*      Minimum safe trip count     : 1
;*----------------------------------------------------------------------------*
;*       SETUP CODE
;*
;*                  MVK             0x1,A0
;*                  ZERO            A3
;*                  ZERO            B4
;*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C181:
;*   0      [ A0]   LDW     .D2T2   *+DP(_rd_num_sec),B4 ; |116|  ^ 
;*   1              NOP             3
;*   4              ADD     .L2     1,B5,B5           ; |116| 
;*   5              OR      .L1     A5,A4,A4          ; |117| 
;*     ||           CMPLTU  .L2     B5,B4,B0          ; |116|  ^ 
;*   6      [ A0]   MV      .L1     A4,A3             ; |116| 
;*     ||   [!B0]   ZERO    .S1     A0                ; |116|  ^ 
;*   7      [ A0]   B       .S2     C181              ; |116| 
;*   8              NOP             3
;*  11              ADD     .L1     A5,A5,A5          ; |118| 
;*  12              NOP             1
;*  13              ; BRANCHCC OCCURS {C181}          ; |116| 
;*
;*       RESTORE CODE
;*
;*                  MV              A3,A4
;*----------------------------------------------------------------------------*
L11:    ; PIPED LOOP PROLOG
;** --------------------------------------------------------------------------*
L12:    ; PIPED LOOP KERNEL

   [ A0]   MV      .L1     A4,A3             ; |116| <0,6> 
|| [!B0]   ZERO    .S1     A0                ; |116| <0,6>  ^ 

   [ A0]   BNOP    .S2     L12,3             ; |116| <0,7> 
|| [ A0]   LDW     .D2T2   *+DP(_rd_num_sec),B4 ; |116| <1,0>  ^ 

           ADD     .L1     A5,A5,A5          ; |118| <0,11> 
||         ADD     .L2     1,B5,B5           ; |116| <1,4> 

           OR      .L1     A5,A4,A4          ; |117| <1,5> 
||         CMPLTU  .L2     B5,B4,B0          ; |116| <1,5>  ^ 

;** --------------------------------------------------------------------------*
L13:    ; PIPED LOOP EPILOG
;** --------------------------------------------------------------------------*
L14:    
;**	-----------------------g15:
;** 120	-----------------------    wr_num_sec = 0u;
;** 122	-----------------------    read_done = 0u;
;** 124	-----------------------    *(volatile unsigned *)0x68000024u = (volatile unsigned)data_in_sec|K$93;
;** 133	-----------------------    if ( *(volatile unsigned *)0x68000024u == 15u ) goto g18;
;**  	-----------------------    #pragma LOOP_FLAGS(4096u)

           MVKL    .S2     0x68000024,B4     ; |124| 
||         ZERO    .L2     B5                ; |122| 
||         ZERO    .L1     A4                ; |120| 
||         MVKL    .S1     0x68000024,A31    ; |133| 
||         OR      .D2X    B9,A3,B31         ; |124| 

           MVKH    .S2     0x68000024,B4     ; |124| 
||         STW     .D2T1   A4,*+DP(_wr_num_sec) ; |120| 
||         MVKH    .S1     0x68000024,A31    ; |133| 

           STW     .D2T2   B5,*+DP(_read_done) ; |122| 
           STW     .D2T2   B31,*B4           ; |124| 
           LDW     .D1T1   *A31,A3           ; |133| 
           NOP             4

           MVKL    .S1     0x68000024,A3     ; |133| (P) <0,0> 
||         CMPEQ   .L1     A3,15,A0          ; |133| 

   [!A0]   MVK     .L2     0x1,B0
||         MVKH    .S1     0x68000024,A3     ; |133| (P) <0,1> 
|| [ A0]   B       .S2     L18               ; |133| 

   [!A0]   MVKL    .S1     0x68000024,A3     ; |133| (P) <1,0> 
|| [!A0]   LDW     .D1T1   *A3,A4            ; |133| (P) <0,2>  ^ 

           NOP             4
           ; BRANCHCC OCCURS {L18}           ; |133| 
;** --------------------------------------------------------------------------*
;**	-----------------------g17:
;** 133	-----------------------    if ( *(volatile unsigned *)0x68000024u != 15u ) goto g17;
           CMPEQ   .L1     A4,15,A0          ; |133| (P) <0,7>  ^ 
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 133
;*      Loop closing brace source line   : 133
;*      Known Minimum Trip Count         : 1                    
;*      Known Max Trip Count Factor      : 1
;*      Loop Carried Dependency Bound(^) : 7
;*      Unpartitioned Resource Bound     : 2
;*      Partitioned Resource Bound(*)    : 2
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     1        0     
;*      .S units                     2*       1     
;*      .D units                     1        0     
;*      .M units                     0        0     
;*      .X cross paths               0        0     
;*      .T address paths             1        0     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          0        1     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             2*       1     
;*      Bound(.L .S .D .LS .LSD)     2*       1     
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 7  Schedule found with 3 iterations in parallel
;*
;*      Register Usage Table:
;*          +-----------------------------------------------------------------+
;*          |AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB|
;*          |00000000001111111111222222222233|00000000001111111111222222222233|
;*          |01234567890123456789012345678901|01234567890123456789012345678901|
;*          |--------------------------------+--------------------------------|
;*       0: |*  **                           |*                               |
;*       1: |   **                           |*                               |
;*       2: |    *                           |*                               |
;*       3: |    *                           |*                               |
;*       4: |    *                           |*                               |
;*       5: |    *                           |*                               |
;*       6: |    *                           |*                               |
;*          +-----------------------------------------------------------------+
;*
;*      Done
;*
;*      Loop is interruptible
;*      Collapsed epilog stages     : 2
;*      Prolog not removed
;*      Collapsed prolog stages     : 0
;*
;*      Minimum required memory pad : 0 bytes
;*
;*      Minimum safe trip count     : 1
;*----------------------------------------------------------------------------*
;*       SETUP CODE
;*
;*                  MVK             0x1,B0
;*                  ZERO            A4
;*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C148:
;*   0              MVKL    .S1     0x68000024,A3     ; |133| 
;*   1              MVKH    .S1     0x68000024,A3     ; |133| 
;*   2      [ B0]   LDW     .D1T1   *A3,A4            ; |133|  ^ 
;*   3              NOP             4
;*   7              CMPEQ   .L1     A4,15,A0          ; |133|  ^ 
;*   8      [ A0]   ZERO    .L2     B0                ; |133|  ^ 
;*   9      [ B0]   B       .S2     C148              ; |133| 
;*  10              NOP             5
;*  15              ; BRANCHCC OCCURS {C148}          ; |133| 
;*----------------------------------------------------------------------------*
L15:    ; PIPED LOOP PROLOG
;** --------------------------------------------------------------------------*
L16:    ; PIPED LOOP KERNEL

   [ A0]   ZERO    .L2     B0                ; |133| <0,8>  ^ 
||         MVKH    .S1     0x68000024,A3     ; |133| <1,1> 

   [ B0]   BNOP    .S2     L16,4             ; |133| <0,9> 
|| [ B0]   LDW     .D1T1   *A3,A4            ; |133| <1,2>  ^ 

           CMPEQ   .L1     A4,15,A0          ; |133| <1,7>  ^ 
||         MVKL    .S1     0x68000024,A3     ; |133| <2,0> 

;** --------------------------------------------------------------------------*
L17:    ; PIPED LOOP EPILOG
;** --------------------------------------------------------------------------*
L18:    
;**	-----------------------g18:
;** 360	-----------------------    imageptrin += 1024;  // [1]
;** 82	-----------------------    if ( --L$1 ) goto g7;

           SUB     .L2     B2,1,B2           ; |82| 
||         ADDK    .S2     4096,B22          ; |360| 

   [ B2]   B       .S1     L6                ; |82| 
|| [ B2]   MVKL    .S2     0x68000020,B4     ; |84| 
|| [ B2]   ZERO    .L2     B31               ; |95| 

   [!B2]   BNOP    .S1     L20,2             ; |82| 
|| [ B2]   MVKH    .S2     0x68000020,B4     ; |84| 

   [ B2]   STW     .D2T2   B10,*B4           ; |84| 
   [ B2]   STW     .D2T2   B31,*+DP(_read_done) ; |95| 
           ; BRANCHCC OCCURS {L6}            ; |82| 
;** --------------------------------------------------------------------------*
;** 82	-----------------------    goto g20;
           EXTU    .S1     A6,20,20,A0       ; |136| 
           ; BRANCH OCCURS {L20}             ; |82| 
;** --------------------------------------------------------------------------*
L19:    
;**	-----------------------g19:
;** 82	-----------------------    i_part = 0;
           EXTU    .S1     A6,20,20,A0       ; |136| 
;** --------------------------------------------------------------------------*
L20:    
;**	-----------------------g20:
;** 136	-----------------------    if ( !_extu((unsigned)imagelen, 20u, 20u) ) goto g32;

   [!A0]   B       .S2     L33               ; |136| 
|| [ A0]   SHR     .S1     A6,11,A3          ; |138| 
|| [ A0]   ZERO    .L2     B31               ; |149| 

   [ A0]   SHRU    .S1     A3,20,A3          ; |138| 
|| [ A0]   MVKL    .S2     0x68000020,B4     ; |145| 

   [ A0]   MVKH    .S2     0x68000020,B4     ; |145| 
|| [!A0]   B       .S1     L1                ; |194| 
|| [ A0]   ADD     .L1     A6,A3,A3          ; |138| 

   [ A0]   AND     .L1     A17,A3,A3         ; |138| 
|| [ A0]   STW     .D2T2   B10,*B4           ; |145| 
|| [!A0]   SHL     .S1     A9,12,A3          ; |191| 
|| [!A0]   MVK     .S2     536,B31           ; |193| 

   [ A0]   SUB     .L1     A6,A3,A16         ; |138| 
|| [ A0]   STW     .D2T2   B31,*+DP(_read_done) ; |149| 
|| [!A0]   ADD     .S1     A16,A3,A3         ; |191| 
|| [!A0]   MVK     .S2     540,B4            ; |191| 

   [!A0]   ADD     .L1     A3,A3,A3          ; |191| 
           ; BRANCHCC OCCURS {L33}           ; |136| 
;** --------------------------------------------------------------------------*
;** 138	-----------------------    mod_len = imagelen-((imagelen>>11>>20)+imagelen&K$113);
;** 145	-----------------------    *(volatile unsigned *)0x68000020u = K$34;
;** 149	-----------------------    read_done = 0u;
;** 354	-----------------------    gie = CSR&1u;  // [0]
;** 355	-----------------------    a$1 = CSR&K$61;  // [0]
;** 355	-----------------------    CSR = a$1;  // [0]
;** 844	-----------------------    *(volatile unsigned *)0x2000004u = (unsigned)imageptrin;  // [5]
;** 845	-----------------------    *(volatile unsigned *)0x2000008u = (mod_len>>1>>30)+mod_len>>2;  // [5]
;** 846	-----------------------    *(volatile unsigned *)0x200000cu = K$71;  // [5]
;** 847	-----------------------    *(volatile unsigned *)0x2000010u = K$75;  // [5]
;** 848	-----------------------    *(volatile unsigned *)0x2000020u = K$79;  // [5]
;** 360	-----------------------    a$2 = CSR&K$61|gie&1u;  // [1]
;** 360	-----------------------    CSR = a$2;  // [1]
;** 158	-----------------------    if ( read_done ) goto g24;
;**  	-----------------------    #pragma LOOP_FLAGS(4096u)
           MVC     .S2     CSR,B4            ; |354| 

           AND     .L2     1,B4,B5           ; |354| 
||         MVC     .S2     CSR,B4            ; |355| 

           AND     .L2     B19,B4,B4         ; |355| 
           MVC     .S2     B4,CSR            ; |355| 

           SHR     .S1     A16,1,A4          ; |845| 
||         MVKL    .S2     0x2000008,B4      ; |845| 

           SHRU    .S1     A4,30,A4          ; |845| 
||         MVKL    .S2     0x200000c,B16     ; |846| 

           MVKL    .S1     0x2000004,A3      ; |844| 
||         ADD     .L1     A16,A4,A4         ; |845| 
||         MVKH    .S2     0x2000008,B4      ; |845| 

           MVKH    .S1     0x2000004,A3      ; |844| 
||         MVKH    .S2     0x200000c,B16     ; |846| 

           SHR     .S1     A4,2,A4           ; |845| 
||         STW     .D1T2   B22,*A3           ; |844| 

           MVKL    .S1     0x2000010,A31     ; |847| 
||         STW     .D2T1   A4,*B4            ; |845| 

           STW     .D2T2   B7,*B16           ; |846| 
||         MVKH    .S1     0x2000010,A31     ; |847| 

           MVKL    .S1     0x2000020,A30     ; |848| 
||         STW     .D1T2   B20,*A31          ; |847| 

           MVKH    .S1     0x2000020,A30     ; |848| 

           STW     .D1T1   A8,*A30           ; |848| 
||         MVC     .S2     CSR,B4            ; |360| 

           AND     .L2     1,B5,B5           ; |360| 
||         AND     .S2     B19,B4,B4         ; |360| 

           OR      .L2     B5,B4,B4          ; |360| 
           MVC     .S2     B4,CSR            ; |360| 
           LDW     .D2T2   *+DP(_read_done),B0 ; |158| 
           NOP             4

   [ B0]   BNOP    .S1     L24,4             ; |158| 
|| [!B0]   MVK     .L2     0x1,B0
|| [!B0]   LDW     .D2T2   *+DP(_read_done),B1 ; |158| (P) <0,0>  ^ 

   [ B1]   ZERO    .L2     B0                ; |158| (P) <0,5>  ^ 
           ; BRANCHCC OCCURS {L24}           ; |158| 
;**	-----------------------g23:
;** 158	-----------------------    if ( !read_done ) goto g23;
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 158
;*      Loop closing brace source line   : 158
;*      Known Minimum Trip Count         : 1                    
;*      Known Max Trip Count Factor      : 1
;*      Loop Carried Dependency Bound(^) : 6
;*      Unpartitioned Resource Bound     : 1
;*      Partitioned Resource Bound(*)    : 1
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        0     
;*      .S units                     1*       0     
;*      .D units                     0        1*    
;*      .M units                     0        0     
;*      .X cross paths               0        0     
;*      .T address paths             0        1*    
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          0        1     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             1*       0     
;*      Bound(.L .S .D .LS .LSD)     1*       1*    
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 6  Schedule found with 2 iterations in parallel
;*
;*      Register Usage Table:
;*          +-----------------------------------------------------------------+
;*          |AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB|
;*          |00000000001111111111222222222233|00000000001111111111222222222233|
;*          |01234567890123456789012345678901|01234567890123456789012345678901|
;*          |--------------------------------+--------------------------------|
;*       0: |                                |**            *                 |
;*       1: |                                |**            *                 |
;*       2: |                                |**            *                 |
;*       3: |                                |**            *                 |
;*       4: |                                |**            *                 |
;*       5: |                                |**            *                 |
;*          +-----------------------------------------------------------------+
;*
;*      Done
;*
;*      Loop is interruptible
;*      Collapsed epilog stages     : 1
;*      Prolog not removed
;*      Collapsed prolog stages     : 0
;*
;*      Minimum required memory pad : 0 bytes
;*
;*      Minimum safe trip count     : 1
;*----------------------------------------------------------------------------*
;*       SETUP CODE
;*
;*                  MVK             0x1,B0
;*                  ZERO            B1
;*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C113:
;*   0      [ B0]   LDW     .D2T2   *+DP(_read_done),B1 ; |158|  ^ 
;*   1              NOP             4
;*   5      [ B1]   ZERO    .L2     B0                ; |158|  ^ 
;*   6      [ B0]   B       .S1     C113              ; |158| 
;*   7              NOP             5
;*  12              ; BRANCHCC OCCURS {C113}          ; |158| 
;*----------------------------------------------------------------------------*
L21:    ; PIPED LOOP PROLOG
;** --------------------------------------------------------------------------*
L22:    ; PIPED LOOP KERNEL

   [ B0]   BNOP    .S1     L22,4             ; |158| <0,6> 
|| [ B0]   LDW     .D2T2   *+DP(_read_done),B1 ; |158| <1,0>  ^ 

   [ B1]   ZERO    .L2     B0                ; |158| <1,5>  ^ 
;** --------------------------------------------------------------------------*
L23:    ; PIPED LOOP EPILOG
;** --------------------------------------------------------------------------*
L24:    
;**	-----------------------g24:
;** 161	-----------------------    rd_num_sec = (mod_len>>9>>22)+mod_len>>10;
;** 162	-----------------------    rd_num_sec = (_extu((unsigned)mod_len, 22u, 22u) != 0u)+rd_num_sec;
;** 162	-----------------------    if ( rd_num_sec <= 4u ) goto g26;
;** 165	-----------------------    rd_num_sec = 4u;
;**	-----------------------g26:
;** 168	-----------------------    data_in_sec = 0;
;** 170	-----------------------    if ( !rd_num_sec ) goto g29;

           SHR     .S2X    A16,9,B4          ; |161| 
||         EXTU    .S1     A16,22,22,A31     ; |162| 
||         MVK     .L2     4,B31             ; |165| 

           SHRU    .S2     B4,22,B4          ; |161| 
           NOP             1
           ADD     .L1X    A16,B4,A3         ; |161| 
           SHR     .S1     A3,10,A3          ; |161| 

           CMPEQ   .L1     A31,0,A3          ; |162| 
||         STW     .D2T1   A3,*+DP(_rd_num_sec) ; |161| 

           XOR     .L1     1,A3,A3           ; |162| 
||         LDW     .D2T2   *+DP(_rd_num_sec),B4 ; |162| 

           NOP             4

           ZERO    .L1     A3                ; |168| 
||         ADD     .L2X    B4,A3,B4          ; |162| 

           STW     .D2T2   B4,*+DP(_rd_num_sec) ; |162| 
           LDW     .D2T2   *+DP(_rd_num_sec),B4 ; |162| 
           NOP             4

           MVK     .S2     0x1,B4            ; |169| 
||         CMPGTU  .L2     B4,4,B0           ; |162| 

   [ B0]   STW     .D2T2   B31,*+DP(_rd_num_sec) ; |165| 

           MV      .L1X    B4,A5
||         LDW     .D2T2   *+DP(_rd_num_sec),B0 ; |170| 

           NOP             4

   [!B0]   BNOP    .S1     L28,3             ; |170| 
|| [ B0]   LDW     .D2T2   *+DP(_rd_num_sec),B4 ; |170| (P) <0,0>  ^ 
|| [ B0]   ZERO    .L2     B5                ; |170| 
|| [ B0]   MV      .L1     A3,A4
|| [ B0]   MVK     .D1     0x1,A0

   [ B0]   ADD     .L2     1,B5,B5           ; |170| (P) <0,4> 
|| [ B0]   OR      .L1     A5,A4,A4          ; |171| (P) <0,5> 

   [ B0]   CMPLTU  .L2     B5,B4,B0          ; |170| (P) <0,5>  ^ 
           ; BRANCHCC OCCURS {L28}           ; |170| 
;** 169	-----------------------    mask = 1;
;** 170	-----------------------    i = 0;
;**  	-----------------------    #pragma LOOP_FLAGS(4096u)
;**	-----------------------g28:
;** 171	-----------------------    data_in_sec |= mask;
;** 172	-----------------------    mask *= 2;
;** 170	-----------------------    if ( (unsigned)(++i) < rd_num_sec ) goto g28;
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 170
;*      Loop opening brace source line   : 170
;*      Loop closing brace source line   : 173
;*      Known Minimum Trip Count         : 1                    
;*      Known Max Trip Count Factor      : 1
;*      Loop Carried Dependency Bound(^) : 7
;*      Unpartitioned Resource Bound     : 2
;*      Partitioned Resource Bound(*)    : 2
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        1     
;*      .S units                     0        1     
;*      .D units                     0        1     
;*      .M units                     0        0     
;*      .X cross paths               0        0     
;*      .T address paths             0        1     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          4        1     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             0        1     
;*      Bound(.L .S .D .LS .LSD)     2*       2*    
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 7  Schedule found with 2 iterations in parallel
;*
;*      Register Usage Table:
;*          +-----------------------------------------------------------------+
;*          |AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB|
;*          |00000000001111111111222222222233|00000000001111111111222222222233|
;*          |01234567890123456789012345678901|01234567890123456789012345678901|
;*          |--------------------------------+--------------------------------|
;*       0: |*  ***                          |*   **        *                 |
;*       1: |*  ***                          |    **        *                 |
;*       2: |*  ***                          |    **        *                 |
;*       3: |*  ***                          |    **        *                 |
;*       4: |*  ***                          |    **        *                 |
;*       5: |*  ***                          |    **        *                 |
;*       6: |*  ***                          |    **        *                 |
;*          +-----------------------------------------------------------------+
;*
;*      Done
;*
;*      Loop is interruptible
;*      Collapsed epilog stages     : 1
;*      Prolog not removed
;*      Collapsed prolog stages     : 0
;*
;*      Minimum required memory pad : 0 bytes
;*
;*      Minimum safe trip count     : 1
;*----------------------------------------------------------------------------*
;*       SETUP CODE
;*
;*                  MVK             0x1,A0
;*                  ZERO            A3
;*                  ZERO            B4
;*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C80:
;*   0      [ A0]   LDW     .D2T2   *+DP(_rd_num_sec),B4 ; |170|  ^ 
;*   1              NOP             3
;*   4              ADD     .L2     1,B5,B5           ; |170| 
;*   5              OR      .L1     A5,A4,A4          ; |171| 
;*     ||           CMPLTU  .L2     B5,B4,B0          ; |170|  ^ 
;*   6      [ A0]   MV      .L1     A4,A3             ; |170| 
;*     ||   [!B0]   ZERO    .S1     A0                ; |170|  ^ 
;*   7      [ A0]   B       .S2     C80               ; |170| 
;*   8              NOP             3
;*  11              ADD     .L1     A5,A5,A5          ; |172| 
;*  12              NOP             1
;*  13              ; BRANCHCC OCCURS {C80}           ; |170| 
;*
;*       RESTORE CODE
;*
;*                  MV              A3,A4
;*----------------------------------------------------------------------------*
L25:    ; PIPED LOOP PROLOG
;** --------------------------------------------------------------------------*
L26:    ; PIPED LOOP KERNEL

   [ A0]   MV      .L1     A4,A3             ; |170| <0,6> 
|| [!B0]   ZERO    .S1     A0                ; |170| <0,6>  ^ 

   [ A0]   BNOP    .S2     L26,3             ; |170| <0,7> 
|| [ A0]   LDW     .D2T2   *+DP(_rd_num_sec),B4 ; |170| <1,0>  ^ 

           ADD     .L1     A5,A5,A5          ; |172| <0,11> 
||         ADD     .L2     1,B5,B5           ; |170| <1,4> 

           OR      .L1     A5,A4,A4          ; |171| <1,5> 
||         CMPLTU  .L2     B5,B4,B0          ; |170| <1,5>  ^ 

;** --------------------------------------------------------------------------*
L27:    ; PIPED LOOP EPILOG
;** --------------------------------------------------------------------------*
L28:    
;**	-----------------------g29:
;** 174	-----------------------    wr_num_sec = 0u;
;** 176	-----------------------    read_done = 0u;
;** 178	-----------------------    *(volatile unsigned *)0x68000024u = (volatile unsigned)data_in_sec|K$93;
;** 187	-----------------------    if ( *(volatile unsigned *)0x68000024u == 15u ) goto g32;
;**  	-----------------------    #pragma LOOP_FLAGS(4096u)

           MVKL    .S2     0x68000024,B4     ; |178| 
||         ZERO    .L2     B5                ; |176| 
||         ZERO    .L1     A4                ; |174| 
||         MVKL    .S1     0x68000024,A31    ; |187| 
||         OR      .D2X    B9,A3,B31         ; |178| 

           MVKH    .S2     0x68000024,B4     ; |178| 
||         STW     .D2T1   A4,*+DP(_wr_num_sec) ; |174| 
||         MVKH    .S1     0x68000024,A31    ; |187| 

           STW     .D2T2   B5,*+DP(_read_done) ; |176| 
           STW     .D2T2   B31,*B4           ; |178| 
           LDW     .D1T1   *A31,A3           ; |187| 
           NOP             4

           MVKL    .S1     0x68000024,A3     ; |187| (P) <0,0> 
||         CMPEQ   .L1     A3,15,A0          ; |187| 

   [!A0]   MVK     .L2     0x1,B0
||         MVKH    .S1     0x68000024,A3     ; |187| (P) <0,1> 
|| [ A0]   B       .S2     L32               ; |187| 

   [!A0]   MVKL    .S1     0x68000024,A3     ; |187| (P) <1,0> 
|| [!A0]   LDW     .D1T1   *A3,A4            ; |187| (P) <0,2>  ^ 

           NOP             4
           ; BRANCHCC OCCURS {L32}           ; |187| 
;** --------------------------------------------------------------------------*
;**	-----------------------g31:
;** 187	-----------------------    if ( *(volatile unsigned *)0x68000024u != 15u ) goto g31;
           CMPEQ   .L1     A4,15,A0          ; |187| (P) <0,7>  ^ 
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 187
;*      Loop closing brace source line   : 187
;*      Known Minimum Trip Count         : 1                    
;*      Known Max Trip Count Factor      : 1
;*      Loop Carried Dependency Bound(^) : 7
;*      Unpartitioned Resource Bound     : 2
;*      Partitioned Resource Bound(*)    : 2
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     1        0     
;*      .S units                     2*       1     
;*      .D units                     1        0     
;*      .M units                     0        0     
;*      .X cross paths               0        0     
;*      .T address paths             1        0     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          0        1     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             2*       1     
;*      Bound(.L .S .D .LS .LSD)     2*       1     
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 7  Schedule found with 3 iterations in parallel
;*
;*      Register Usage Table:
;*          +-----------------------------------------------------------------+
;*          |AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB|
;*          |00000000001111111111222222222233|00000000001111111111222222222233|
;*          |01234567890123456789012345678901|01234567890123456789012345678901|
;*          |--------------------------------+--------------------------------|
;*       0: |*  **                           |*                               |
;*       1: |   **                           |*                               |
;*       2: |    *                           |*                               |
;*       3: |    *                           |*                               |
;*       4: |    *                           |*                               |
;*       5: |    *                           |*                               |
;*       6: |    *                           |*                               |
;*          +-----------------------------------------------------------------+
;*
;*      Done
;*
;*      Loop is interruptible
;*      Collapsed epilog stages     : 2
;*      Prolog not removed
;*      Collapsed prolog stages     : 0
;*
;*      Minimum required memory pad : 0 bytes
;*
;*      Minimum safe trip count     : 1
;*----------------------------------------------------------------------------*
;*       SETUP CODE
;*
;*                  MVK             0x1,B0
;*                  ZERO            A4
;*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C47:
;*   0              MVKL    .S1     0x68000024,A3     ; |187| 
;*   1              MVKH    .S1     0x68000024,A3     ; |187| 
;*   2      [ B0]   LDW     .D1T1   *A3,A4            ; |187|  ^ 
;*   3              NOP             4
;*   7              CMPEQ   .L1     A4,15,A0          ; |187|  ^ 
;*   8      [ A0]   ZERO    .L2     B0                ; |187|  ^ 
;*   9      [ B0]   B       .S2     C47               ; |187| 
;*  10              NOP             5
;*  15              ; BRANCHCC OCCURS {C47}           ; |187| 
;*----------------------------------------------------------------------------*
L29:    ; PIPED LOOP PROLOG
;** --------------------------------------------------------------------------*
L30:    ; PIPED LOOP KERNEL

   [ A0]   ZERO    .L2     B0                ; |187| <0,8>  ^ 
||         MVKH    .S1     0x68000024,A3     ; |187| <1,1> 

   [ B0]   BNOP    .S2     L30,4             ; |187| <0,9> 
|| [ B0]   LDW     .D1T1   *A3,A4            ; |187| <1,2>  ^ 

           CMPEQ   .L1     A4,15,A0          ; |187| <1,7>  ^ 
||         MVKL    .S1     0x68000024,A3     ; |187| <2,0> 

;** --------------------------------------------------------------------------*
L31:    ; PIPED LOOP EPILOG
;** --------------------------------------------------------------------------*
L32:    
           B       .S1     L1                ; |194| 
           SHL     .S1     A9,12,A3          ; |191| 

           ADD     .L1     A16,A3,A3         ; |191| 
||         MVK     .S2     540,B4            ; |191| 

           ADD     .L1     A3,A3,A3          ; |191| 
||         MVK     .S2     536,B31           ; |193| 

;** --------------------------------------------------------------------------*
L33:    
;**	-----------------------g32:
;** 191	-----------------------    *(volatile unsigned *)0x21cu = ((i_part<<12)+mod_len)*2;
;** 193	-----------------------    *(volatile unsigned *)0x218u = K$42;
;** 194	-----------------------    goto g2;

           STW     .D2T1   A3,*B4            ; |191| 
||         MVK     .S2     524,B4            ; |65| 

           STW     .D2T2   B18,*B31          ; |193| 
           ; BRANCH OCCURS {L1}              ; |194| 
;; Inlined function references:
;; [  0] IRQ_globalDisable
;; [  1] IRQ_globalRestore
;; [  4] CSL_init
;; [  5] EDMA_qdmaConfigArgs
;******************************************************************************
;* UNDEFINED EXTERNAL REFERENCES                                              *
;******************************************************************************
	.global	__CSL_init
	.global	_CSL6416_LIB_
	.global	_MemportInit
