;******************************************************************************
;* TMS320C6x C/C++ Codegen                                          PC v5.1.0 *
;* Date/Time created: Fri Jul 25 15:37:47 2008                                *
;******************************************************************************
	.compiler_opts --endian=little --mem_model:code=near --mem_model:data=far_aggregates --quiet --silicon_version=6416 --symdebug:none 

;******************************************************************************
;* GLOBAL FILE PARAMETERS                                                     *
;*                                                                            *
;*   Architecture      : TMS320C64xx                                          *
;*   Optimization      : Enabled at level 3                                   *
;*   Optimizing for    : Speed                                                *
;*                       Based on options: -o3, no -ms                        *
;*   Endian            : Little                                               *
;*   Interrupt Thrshld : Disabled                                             *
;*   Data Access Model : Far Aggregate Data                                   *
;*   Pipelining        : Enabled                                              *
;*   Speculate Loads   : Disabled                                             *
;*   Memory Aliases    : Presume are aliases (pessimistic)                    *
;*   Debug Info        : No Debug Info                                        *
;*                                                                            *
;******************************************************************************

	.asg	A15, FP
	.asg	B14, DP
	.asg	B15, SP
	.global	$bss

	.global	_sec_out_clr
	.bss	_sec_out_clr,2,2
;	c:\pf\CCStudio_v3.1\C6000\cgtools\bin\opt6x.exe --gen_opt_info=2 c:\DOCUME~1\kloub\LOCALS~1\Temp\TI5122 c:\DOCUME~1\kloub\LOCALS~1\Temp\TI5124 --opt_info_filename=memport.nfo 
	.sect	".text"
	.global	_MemportInit

;******************************************************************************
;* FUNCTION NAME: _MemportInit                                                *
;*                                                                            *
;*   Regs Modified     : A3,A4,A5,B4,B5                                       *
;*   Regs Used         : A3,A4,A5,B3,B4,B5,DP                                 *
;*   Local Frame Size  : 0 Args + 0 Auto + 0 Save = 0 byte                    *
;******************************************************************************
_MemportInit:
;** --------------------------------------------------------------------------*
;** 369	-----------------------    CSR = CSR&0xfffffffeu;  // [6]
;** 370	-----------------------    IER = 0u;  // [6]
;** 371	-----------------------    ICR = 0xffffffffu;  // [6]
;** 371	-----------------------    CSR = CSR|1u;  // [6]
;** 350	-----------------------    IER |= 2u;  // [3]
;** 320	-----------------------    C$1 = &_IRQ_eventTable[0];  // [0]
;** 320	-----------------------    IER |= C$1[8];  // [0]
;** 354	-----------------------    gie = CSR&1u;  // [4]
;** 355	-----------------------    CSR = CSR&0xfffffffeu;  // [4]
;** 356	-----------------------    *(volatile unsigned *)0x1a0ffe8u = *(volatile unsigned *)0x1a0ffe8u|0x100u;  // [4]
;** 360	-----------------------    CSR = CSR&0xfffffffeu|gie&1u;  // [5]
;** 360	-----------------------    sec_out_clr = 0u;  // [5]
;** 32	-----------------------    wr_num_sec = 0u;
;** 34	-----------------------    *(volatile unsigned *)0x68000024u = C$2 = 4080u;
;** 35	-----------------------    *(volatile unsigned *)0x68000034u = C$2;
;** 320	-----------------------    IER |= C$1[4];  // [0]
;** 320	-----------------------    return;  // [0]
           MVC     .S2     CSR,B4            ; |369| 
           AND     .L2     -2,B4,B4          ; |369| 
           MVC     .S2     B4,CSR            ; |369| 
           ZERO    .L2     B4                ; |370| 
           MVC     .S2     B4,IER            ; |370| 
           MVK     .L1     -1,A3             ; |371| 
           NOP             1
           MVC     .S2X    A3,ICR            ; |371| 
           MVC     .S2     CSR,B4            ; |371| 
           OR      .L2     1,B4,B4           ; |371| 
           MVC     .S2     B4,CSR            ; |371| 
           MVC     .S2     IER,B4            ; |350| 
           OR      .L2     2,B4,B4           ; |350| 
           MVC     .S2     B4,IER            ; |350| 
           MVKL    .S1     __IRQ_eventTable,A3 ; |320| 

           MVC     .S2     IER,B4            ; |320| 
||         MVKH    .S1     __IRQ_eventTable,A3 ; |320| 

           LDW     .D1T1   *+A3(32),A4       ; |320| 
           NOP             4
           OR      .L2X    A4,B4,B4          ; |320| 
           MVC     .S2     B4,IER            ; |320| 
           MVC     .S2     CSR,B4            ; |354| 

           MVC     .S2     CSR,B5            ; |355| 
||         AND     .L2     1,B4,B4           ; |354| 

           AND     .L2     -2,B5,B5          ; |355| 
           MVC     .S2     B5,CSR            ; |355| 
           MVKL    .S1     0x1a0ffe8,A4      ; |356| 
           MVKH    .S1     0x1a0ffe8,A4      ; |356| 
           LDW     .D1T1   *A4,A5            ; |356| 
           NOP             2
           MVKL    .S1     0x1a0ffe8,A4      ; |356| 
           MVKH    .S1     0x1a0ffe8,A4      ; |356| 
           SET     .S1     A5,8,8,A5         ; |356| 

           MVC     .S2     CSR,B5            ; |360| 
||         STW     .D1T1   A5,*A4            ; |356| 

           AND     .L2     1,B4,B5           ; |360| 
||         AND     .S2     -2,B5,B4          ; |360| 

           OR      .L2     B5,B4,B4          ; |360| 
           MVC     .S2     B4,CSR            ; |360| 

           MVKL    .S1     0x68000024,A5     ; |34| 
||         ZERO    .L1     A4                ; |360| 

           MVKH    .S1     0x68000024,A5     ; |34| 
||         STH     .D2T1   A4,*+DP(_sec_out_clr) ; |360| 
||         ZERO    .L2     B4                ; |32| 

           MVK     .S2     0xff0,B4          ; |34| 
||         STW     .D2T2   B4,*+DP(_wr_num_sec) ; |32| 
||         MVKL    .S1     0x68000034,A4     ; |35| 

           STW     .D1T2   B4,*A5            ; |34| 
||         MVKH    .S1     0x68000034,A4     ; |35| 

           MVC     .S2     IER,B4            ; |320| 
||         STW     .D1T2   B4,*A4            ; |35| 

           LDW     .D1T1   *+A3(16),A3       ; |320| 
           NOP             4
           OR      .L2X    A3,B4,B4          ; |320| 
           MVC     .S2     B4,IER            ; |320| 
           RETNOP  .S2     B3,5              ; |38| 
           ; BRANCH OCCURS {B3}              ; |38| 
	.sect	".text"
	.global	_IsrExtInt4

;******************************************************************************
;* FUNCTION NAME: _IsrExtInt4                                                 *
;*                                                                            *
;*   Regs Modified     : A0,A1,A3,A4,A5,A6,A7,A8,B0,B1,B4,B5,B6,B7,B8,B9,SP,  *
;*                           B16,B17                                          *
;*   Regs Used         : A0,A1,A3,A4,A5,A6,A7,A8,B0,B1,B4,B5,B6,B7,B8,B9,DP,  *
;*                           SP,B16,B17                                       *
;*   Local Frame Size  : 0 Args + 0 Auto + 72 Save = 72 byte                  *
;******************************************************************************
_IsrExtInt4:
;** --------------------------------------------------------------------------*
;** 354	-----------------------    gie = CSR&1u;  // [4]
;** 355	-----------------------    CSR = CSR&0xfffffffeu;  // [4]
;** 356	-----------------------    gie = gie;  // [4]
;** 342	-----------------------    ICR = _IRQ_eventTable[4];  // [2]
;** 342	-----------------------    sec_ready = *(volatile unsigned *)0x68000024u;  // [2]
;**  	-----------------------    U$23 = _extu(sec_ready, 20u, 24u);
;** 117	-----------------------    sec_out_num = 0u;
;** 118	-----------------------    sec_out_off = 0u;
;** 119	-----------------------    mask = 1u;
;** 120	-----------------------    i = 0;
;**  	-----------------------    #pragma MUST_ITERATE(8, 8, 8)
;**  	-----------------------    #pragma LOOP_FLAGS(4096u)
;**	-----------------------g2:
;** 121	-----------------------    if ( (int)(unsigned)mask&U$23 ) goto g5;
;**  	-----------------------    if ( !sec_out_num ) goto g8;
;** 128	-----------------------    mask = 0u;
;**  	-----------------------    goto g8;
;**	-----------------------g5:
;**  	-----------------------    if ( sec_out_num ) goto g7;
;** 123	-----------------------    sec_out_off = i;
;**	-----------------------g7:
;** 125	-----------------------    ++sec_out_num;
;**	-----------------------g8:
;** 130	-----------------------    mask *= 2;
;** 120	-----------------------    if ( (++i) < 8 ) goto g2;
;** 135	-----------------------    *(volatile unsigned *)0x68000020u = (sec_out_off<<10)+4096u>>1;
           STW     .D2T1   A8,*SP--(72)      ; |99| 
           STDW    .D2T2   B9:B8,*+SP(56)    ; |99| 
           STDW    .D2T2   B17:B16,*+SP(64)  ; |99| 
           STDW    .D2T2   B7:B6,*+SP(48)    ; |99| 
           STDW    .D2T2   B1:B0,*+SP(32)    ; |99| 
           STDW    .D2T2   B5:B4,*+SP(40)    ; |99| 
           STDW    .D2T1   A5:A4,*+SP(16)    ; |99| 
           STW     .D2T1   A3,*+SP(4)        ; |99| 
           STDW    .D2T1   A1:A0,*+SP(8)     ; |99| 

           MVC     .S2     CSR,B4            ; |354| 
||         STDW    .D2T1   A7:A6,*+SP(24)    ; |99| 

           MVC     .S2     CSR,B4            ; |355| 
||         AND     .L2     1,B4,B5           ; |354| 

           AND     .L2     -2,B4,B4          ; |355| 
           MVC     .S2     B4,CSR            ; |355| 
           MVKL    .S2     __IRQ_eventTable+16,B4 ; |342| 
           MVKH    .S2     __IRQ_eventTable+16,B4 ; |342| 
           LDW     .D2T2   *B4,B4            ; |342| 
           NOP             4

           MVC     .S2     B4,ICR            ; |342| 
||         MV      .L2     B5,B17            ; |356| 

           MVKL    .S1     0x68000024,A3     ; |342| 
           MVKH    .S1     0x68000024,A3     ; |342| 
           LDW     .D1T1   *A3,A3            ; |342| 
           MVK     .L1     0x1,A5            ; |119| 
           ZERO    .D1     A4                ; |117| 
           MVK     .L2     0x1,B1
           ZERO    .S2     B7                ; |120| 
           EXTU    .S1     A3,20,24,A6

           AND     .S1     A6,A5,A1          ; |121| (P) <0,0>  ^ 
||         CMPEQ   .L1     A4,0,A3           ; (P) <0,0> 

           OR      .L1     A3,A1,A0          ; (P) <0,1>  ^ 

           ZERO    .L2     B4                ; |117| 
|| [!A0]   ZERO    .S1     A5                ; |128| (P) <0,2>  ^ 
||         CMPEQ   .L1     A1,0,A3           ; (P) <0,1> 
||         ADD     .D2     1,B7,B7           ; |120| (P) <0,3> 
||         MVC     .S2     CSR,B9

           ZERO    .S2     B6                ; |118| 
|| [ A1]   ADD     .L1     1,A4,A4           ; |125| (P) <0,2> Define a twin register
||         OR      .D1     A4,A3,A0          ; (P) <0,2> 
||         EXTU    .S1     A5,17,16,A5       ; |130| (P) <0,3>  ^ 
||         CMPLT   .L2     B7,8,B0           ; |120| (P) <0,4> 
||         AND     .D2     -2,B9,B16

   [!B0]   ZERO    .L2     B1                ; |120| (P) <0,5> 
||         AND     .S1     A6,A5,A1          ; |121| (P) <1,0>  ^ 
||         CMPEQ   .L1     A4,0,A3           ; (P) <1,0> 
|| [ A1]   ADD     .D2     1,B4,B4           ; |125| (P) <0,1> 
||         MVC     .S2     B16,CSR           ; interrupts off

           CMPEQ   .L1     A1,0,A3           ; (P) <1,1> 
|| [ A1]   ADD     .L2     1,B4,B4           ; |125| (P) <1,1> 
||         OR      .S1     A3,A1,A0          ; (P) <1,1>  ^ 
|| [!A0]   ZERO    .S2     B6                ; |120| 
||         MV      .D2     B4,B5             ; |120| (P) <0,2> 

;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 120
;*      Loop opening brace source line   : 120
;*      Loop closing brace source line   : 131
;*      Known Minimum Trip Count         : 8                    
;*      Known Maximum Trip Count         : 8                    
;*      Known Max Trip Count Factor      : 8
;*      Loop Carried Dependency Bound(^) : 4
;*      Unpartitioned Resource Bound     : 3
;*      Partitioned Resource Bound(*)    : 3
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     2        1     
;*      .S units                     1        1     
;*      .D units                     0        0     
;*      .M units                     0        0     
;*      .X cross paths               0        0     
;*      .T address paths             0        0     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          5        6     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             2        1     
;*      Bound(.L .S .D .LS .LSD)     3*       3*    
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 4  Schedule found with 3 iterations in parallel
;*
;*      Register Usage Table:
;*          +-----------------------------------------------------------------+
;*          |AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB|
;*          |00000000001111111111222222222233|00000000001111111111222222222233|
;*          |01234567890123456789012345678901|01234567890123456789012345678901|
;*          |--------------------------------+--------------------------------|
;*       0: |    ***                         | *  *****                       |
;*       1: | * ****                         |**  *****                       |
;*       2: |** ****                         | *  *****                       |
;*       3: |*   ***                         | *  *****                       |
;*          +-----------------------------------------------------------------+
;*
;*      Done
;*
;*      Collapsed epilog stages     : 2
;*      Prolog not removed
;*      Collapsed prolog stages     : 0
;*
;*      Minimum required memory pad : 0 bytes
;*
;*      Minimum safe trip count     : 1
;*----------------------------------------------------------------------------*
;*       SETUP CODE
;*
;*                  MVK             0x1,B1
;*                  ZERO            B8
;*                  ZERO            B5
;*                  MV              A4,B4
;*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C98:
;*   0              AND     .S1     A6,A5,A1          ; |121|  ^ 
;*     ||           CMPEQ   .L1     A4,0,A3
;*   1              OR      .S1     A3,A1,A0          ;  ^ 
;*     ||           CMPEQ   .L1     A1,0,A3
;*     ||   [ A1]   ADD     .L2     1,B4,B4           ; |125| 
;*   2      [!A0]   ZERO    .S1     A5                ; |128|  ^ 
;*     ||           OR      .D1     A4,A3,A0
;*     ||   [ A1]   ADD     .L1     1,A4,A4           ; |125| Define a twin register
;*     ||   [ B1]   MV      .L2     B4,B5             ; |120| 
;*   3      [!A0]   MV      .L2     B7,B6             ; |123| 
;*     ||           EXTU    .S1     A5,17,16,A5       ; |130|  ^ 
;*     ||           ADD     .S2     1,B7,B7           ; |120| 
;*   4              CMPLT   .L2     B7,8,B0           ; |120| 
;*     ||   [ B1]   MV      .S2     B6,B8             ; |120| 
;*   5      [!B0]   ZERO    .S2     B1                ; |120| 
;*   6      [ B1]   B       .S2     C98               ; |120| 
;*   7              NOP             5
;*  12              ; BRANCHCC OCCURS {C98}           ; |120| 
;*
;*       RESTORE CODE
;*
;*                  MV              B5,A4
;*                  MV              B8,B6
;*----------------------------------------------------------------------------*
L1:    ; PIPED LOOP PROLOG

   [ B1]   MV      .L2     B4,B5             ; |120| (P) <1,2> 
|| [ A1]   ADD     .L1     1,A4,A4           ; |125| (P) <1,2> Define a twin register
|| [!A0]   ZERO    .S1     A5                ; |128| (P) <1,2>  ^ 
||         OR      .D1     A4,A3,A0          ; (P) <1,2> 
|| [ B1]   B       .S2     L2                ; |120| (P) <0,6> 

           MV      .L2     B6,B8             ; |120| (P) <0,4> 
|| [!A0]   MV      .S2     B7,B6             ; |123| (P) <1,3> 
||         ADD     .D2     1,B7,B7           ; |120| (P) <1,3> 
||         EXTU    .S1     A5,17,16,A5       ; |130| (P) <1,3>  ^ 

;** --------------------------------------------------------------------------*
L2:    ; PIPED LOOP KERNEL

   [ B1]   MV      .S2     B6,B8             ; |120| <1,4> 
||         CMPLT   .L2     B7,8,B0           ; |120| <1,4> 
||         CMPEQ   .L1     A4,0,A3           ; <2,0> 
||         AND     .S1     A6,A5,A1          ; |121| <2,0>  ^ 

   [!B0]   ZERO    .S2     B1                ; |120| <1,5> 
|| [ A1]   ADD     .L2     1,B4,B4           ; |125| <2,1> 
||         OR      .S1     A3,A1,A0          ; <2,1>  ^ 
||         CMPEQ   .L1     A1,0,A3           ; <2,1> 

   [ B1]   B       .S2     L2                ; |120| <1,6> 
|| [ B1]   MV      .L2     B4,B5             ; |120| <2,2> 
|| [ A1]   ADD     .L1     1,A4,A4           ; |125| <2,2> Define a twin register
|| [!A0]   ZERO    .S1     A5                ; |128| <2,2>  ^ 
||         OR      .D1     A4,A3,A0          ; <2,2> 

           EXTU    .S1     A5,17,16,A5       ; |130| <2,3>  ^ 
|| [!A0]   MV      .L2     B7,B6             ; |123| <2,3> 
||         ADD     .S2     1,B7,B7           ; |120| <2,3> 

;** --------------------------------------------------------------------------*
L3:    ; PIPED LOOP EPILOG
;** --------------------------------------------------------------------------*
;** 136	-----------------------    *(volatile unsigned *)0x68000020u;
;** 141	-----------------------    C$3 = imageptrout;
;** 141	-----------------------    dst = (unsigned)C$3;
;** 354	-----------------------    gie = CSR&1u;  // [4]
;** 355	-----------------------    CSR = CSR&(K$2 = 0xfffffffeu);  // [4]
;** 844	-----------------------    *(volatile unsigned *)0x2000004u = 0x68000030u;  // [10]
;** 845	-----------------------    C$4 = sec_out_num<<8;  // [10]
;** 845	-----------------------    *(volatile unsigned *)0x2000008u = C$4&0x3fffffffu;  // [10]
;** 846	-----------------------    *(volatile unsigned *)0x200000cu = dst;  // [10]
;** 847	-----------------------    *(volatile unsigned *)0x2000010u = 4u;  // [10]
;** 848	-----------------------    *(volatile unsigned *)0x2000020u = 0x40380001u;  // [10]
;** 360	-----------------------    CSR = CSR&K$2|gie&1u;  // [5]
;** 360	-----------------------    imageptrout = &C$3[C$4];  // [5]
;** 150	-----------------------    *(volatile unsigned *)0x68000034u = 0u;
;** 153	-----------------------    mask = 0u;
;** 154	-----------------------    if ( !sec_out_num ) goto g12;
;**  	-----------------------    L$2 = sec_out_num;
;**  	-----------------------    #pragma MUST_ITERATE(1, 1099511627775, 1)
;**  	-----------------------    #pragma LOOP_FLAGS(4096u)

           MV      .L2     B8,B6
||         MVKL    .S1     0x68000020,A4     ; |135| 
||         MVKL    .S2     0x68000020,B4     ; |136| 
||         MV      .D2     B5,B0

           MVKH    .S1     0x68000020,A4     ; |135| 
||         MVKH    .S2     0x68000020,B4     ; |136| 

           SHL     .S1X    B6,10,A3          ; |135| 
||         MVC     .S2     B9,CSR            ; interrupts on

           ADDK    .S1     4096,A3           ; |135| 
           SHRU    .S1     A3,1,A3           ; |135| 
           STW     .D1T1   A3,*A4            ; |135| 
           LDW     .D2T2   *+DP(_imageptrout),B7 ; |141| 
           LDW     .D2T2   *B4,B4            ; |136| 
           NOP             3
           MV      .L1X    B7,A3             ; |141| 
           MVC     .S2     CSR,B4            ; |354| 

           AND     .L2     1,B4,B8           ; |354| 
||         MVK     .D2     0xfffffffe,B5     ; |355| 
||         MVC     .S2     CSR,B4            ; |355| 

           AND     .L2     B5,B4,B4          ; |355| 
           MVC     .S2     B4,CSR            ; |355| 

           MVKL    .S2     0x2000008,B4      ; |845| 
||         MVKL    .S1     0x68000030,A7     ; |844| 

           MVKL    .S1     0x2000004,A8      ; |844| 
||         MVKH    .S2     0x2000008,B4      ; |845| 

           MVKH    .S1     0x2000004,A8      ; |844| 
||         EXTU    .S2     B0,10,2,B9        ; |845| 

           MVKH    .S1     0x68000030,A7     ; |844| 

           MVKL    .S1     0x200000c,A6      ; |846| 
||         STW     .D1T1   A7,*A8            ; |844| 
||         STW     .D2T2   B9,*B4            ; |845| 
||         MVKL    .S2     0x40380001,B4     ; |848| 

           MVKH    .S1     0x200000c,A6      ; |846| 
||         MVKH    .S2     0x40380001,B4     ; |848| 

           MVKL    .S1     0x2000010,A5      ; |847| 
||         STW     .D1T1   A3,*A6            ; |846| 
||         MVK     .L1     4,A3              ; |847| 
||         SHL     .S2     B0,8,B9           ; |845| 

           MVKL    .S1     0x2000020,A4      ; |848| 
           MVKH    .S1     0x2000020,A4      ; |848| 
           MVKH    .S1     0x2000010,A5      ; |847| 
           STW     .D1T1   A3,*A5            ; |847| 

           STW     .D1T2   B4,*A4            ; |848| 
||         MVC     .S2     CSR,B4            ; |360| 

           AND     .L2     1,B8,B8           ; |360| 
||         AND     .S2     B5,B4,B4          ; |360| 

           OR      .L2     B8,B4,B4          ; |360| 
           MVC     .S2     B4,CSR            ; |360| 

   [!B0]   BNOP    .S1     L7,3              ; |154| 
||         ADDAW   .D2     B7,B9,B7          ; |360| 
||         MVKL    .S2     0x68000034,B4     ; |150| 
|| [ B0]   SUB     .L2     B0,1,B0

           STW     .D2T2   B7,*+DP(_imageptrout) ; |360| 
||         MVKH    .S2     0x68000034,B4     ; |150| 
||         ZERO    .L2     B7                ; |150| 

           STW     .D2T2   B7,*B4            ; |150| 
||         ZERO    .L2     B4                ; |153| 

           ; BRANCHCC OCCURS {L7}            ; |154| 
;**	-----------------------g11:
;** 155	-----------------------    mask = mask*2|1;
;** 154	-----------------------    if ( --L$2 ) goto g11;
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 154
;*      Loop opening brace source line   : 154
;*      Loop closing brace source line   : 157
;*      Known Minimum Trip Count         : 1                    
;*      Known Max Trip Count Factor      : 1
;*      Loop Carried Dependency Bound(^) : 3
;*      Unpartitioned Resource Bound     : 1
;*      Partitioned Resource Bound(*)    : 1
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        0     
;*      .S units                     1*       1*    
;*      .D units                     0        0     
;*      .M units                     0        0     
;*      .X cross paths               0        0     
;*      .T address paths             0        0     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          2        0     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             1*       1*    
;*      Bound(.L .S .D .LS .LSD)     1*       1*    
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 3  Schedule found with 2 iterations in parallel
;*
;*      Register Usage Table:
;*          +-----------------------------------------------------------------+
;*          |AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB|
;*          |00000000001111111111222222222233|00000000001111111111222222222233|
;*          |01234567890123456789012345678901|01234567890123456789012345678901|
;*          |--------------------------------+--------------------------------|
;*       0: |    *                           |*                               |
;*       1: |   *                            |*                               |
;*       2: |   *                            |*                               |
;*          +-----------------------------------------------------------------+
;*
;*      Done
;*
;*      Collapsed epilog stages     : 1
;*      Collapsed prolog stages     : 0
;*      Minimum required memory pad : 0 bytes
;*
;*      Minimum safe trip count     : 1
;*----------------------------------------------------------------------------*
;*       SETUP CODE
;*
;*                  SUB             B0,1,B0
;*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C41:
;*   0      [ B0]   BDEC    .S2     C41,B0            ; |154| 
;*   1              NOP             2
;*   3              ADD     .L1     A4,A4,A3          ; |155|  ^ 
;*   4              OR      .L1     1,A3,A3           ; |155|  ^ 
;*   5              EXTU    .S1     A3,16,16,A4       ; |155|  ^ 
;*   6              ; BRANCHCC OCCURS {C41}           ; |154| 
;*----------------------------------------------------------------------------*
L4:    ; PIPED LOOP PROLOG
   [ B0]   BDEC    .S2     L5,B0             ; |154| (P) <0,0> 
           NOP             1
           MV      .L1X    B4,A4
;** --------------------------------------------------------------------------*
L5:    ; PIPED LOOP KERNEL

           ADD     .L1     A4,A4,A3          ; |155| <0,3>  ^ 
|| [ B0]   BDEC    .S2     L5,B0             ; |154| <1,0> 

           OR      .L1     1,A3,A3           ; |155| <0,4>  ^ 
           EXTU    .S1     A3,16,16,A4       ; |155| <0,5>  ^ 
;** --------------------------------------------------------------------------*
L6:    ; PIPED LOOP EPILOG
;** --------------------------------------------------------------------------*
           NOP             1
           MV      .L2X    A4,B4
;** --------------------------------------------------------------------------*
L7:    
;**	-----------------------g12:
;** 158	-----------------------    mask <<= sec_out_off;
;** 160	-----------------------    sec_out_clr = mask;
;** 162	-----------------------    ext_int = 1u;
;** 324	-----------------------    IER;  // [1]
;** 325	-----------------------    IER = IER&~_IRQ_eventTable[4];  // [1]
;** 360	-----------------------    CSR = CSR&K$2|gie&1u;  // [5]
;** 360	-----------------------    return;  // [5]
           SHL     .S2     B4,B6,B4          ; |158| 

           MVK     .L2     1,B4              ; |162| 
||         STH     .D2T2   B4,*+DP(_sec_out_clr) ; |160| 

           MVC     .S2     IER,B4            ; |324| 
||         STW     .D2T2   B4,*+DP(_ext_int) ; |162| 

           MVKL    .S1     __IRQ_eventTable+16,A3 ; |325| 
           MVKH    .S1     __IRQ_eventTable+16,A3 ; |325| 
           LDW     .D1T1   *A3,A3            ; |325| 
           NOP             3
           MVC     .S2     IER,B4            ; |325| 
           ANDN    .L2X    B4,A3,B4          ; |325| 
           MVC     .S2     B4,IER            ; |325| 
           MVC     .S2     CSR,B4            ; |360| 

           AND     .L2     1,B17,B5          ; |360| 
||         AND     .S2     B5,B4,B4          ; |360| 

           OR      .L2     B5,B4,B4          ; |360| 
           MVC     .S2     B4,CSR            ; |360| 
           LDDW    .D2T1   *+SP(8),A1:A0     ; |166| 
           LDDW    .D2T1   *+SP(16),A5:A4    ; |166| 
           LDDW    .D2T1   *+SP(24),A7:A6    ; |166| 
           LDDW    .D2T2   *+SP(32),B1:B0    ; |166| 
           LDDW    .D2T2   *+SP(56),B9:B8    ; |166| 
           LDDW    .D2T2   *+SP(48),B7:B6    ; |166| 
           LDDW    .D2T2   *+SP(64),B17:B16  ; |166| 
           LDW     .D2T1   *+SP(4),A3        ; |166| 

           RET     .S2     IRP               ; |166| 
||         LDDW    .D2T2   *+SP(40),B5:B4    ; |166| 

           LDW     .D2T1   *++SP(72),A8      ; |166| 
           NOP             4
           ; BRANCH OCCURS {IRP}             ; |166| 
	.sect	".text"
	.global	_IsrEdmaInt

;******************************************************************************
;* FUNCTION NAME: _IsrEdmaInt                                                 *
;*                                                                            *
;*   Regs Modified     : A0,A3,A4,B0,B4,B5,B6,B7,SP                           *
;*   Regs Used         : A0,A3,A4,B0,B4,B5,B6,B7,DP,SP                        *
;*   Local Frame Size  : 0 Args + 4 Auto + 32 Save = 36 byte                  *
;******************************************************************************
_IsrEdmaInt:
;** --------------------------------------------------------------------------*
;** 354	-----------------------    gie = CSR&1u;  // [4]
;** 355	-----------------------    CSR = CSR&0xfffffffeu;  // [4]
;** 356	-----------------------    gie = gie;  // [4]
;** 342	-----------------------    ICR = _IRQ_eventTable[8];  // [2]
;** 671	-----------------------    *(volatile unsigned *)0x1a0ffe4u = 256u;  // [9]
;** 671	-----------------------    if ( !sec_out_clr ) goto g7;  // [9]
           STW     .D2T2   B0,*SP--(40)      ; |42| 
           STW     .D2T1   A0,*+SP(12)       ; |42| 
           STW     .D2T1   A3,*+SP(16)       ; |42| 
           STW     .D2T1   A4,*+SP(20)       ; |42| 
           STDW    .D2T2   B5:B4,*+SP(24)    ; |42| 

           STDW    .D2T2   B7:B6,*+SP(32)    ; |42| 
||         MVC     .S2     CSR,B4            ; |354| 

           AND     .L2     1,B4,B7           ; |354| 
||         MVC     .S2     CSR,B4            ; |355| 

           AND     .L2     -2,B4,B4          ; |355| 
           MVC     .S2     B4,CSR            ; |355| 
           MVKL    .S1     __IRQ_eventTable+32,A3 ; |342| 
           MVKH    .S1     __IRQ_eventTable+32,A3 ; |342| 
           LDW     .D1T1   *A3,A3            ; |342| 
           NOP             4
           MVC     .S2X    A3,ICR            ; |342| 

           MVKL    .S2     0x1a0ffe4,B4      ; |671| 
||         MVK     .L1     0x1,A4            ; |58| 
||         MVK     .S1     0x8,A3            ; |59| 

           MVKH    .S2     0x1a0ffe4,B4      ; |671| 
           MVK     .S2     256,B5            ; |671| 

           STW     .D2T2   B5,*B4            ; |671| 
||         ZERO    .L2     B4                ; |57| 

           LDHU    .D2T2   *+DP(_sec_out_clr),B0 ; |671| 
           NOP             4

   [!B0]   BNOP    .S1     L11,5             ; |671| 
|| [ B0]   MV      .L2X    A4,B6
|| [ B0]   SUB     .L1     A3,1,A0
|| [ B0]   STW     .D2T2   B4,*+SP(4)        ; |57| 

           ; BRANCHCC OCCURS {L11}           ; |671| 
;** 57	-----------------------    sec_num = 0u;
;** 59	-----------------------    L$1 = 8;
;** 58	-----------------------    mask = 1u;
;**  	-----------------------    #pragma MUST_ITERATE(8, 8, 8)
;**  	-----------------------    #pragma LOOP_FLAGS(4096u)
;**	-----------------------g3:
;** 60	-----------------------    if ( !(sec_out_clr&mask) ) goto g5;
;** 60	-----------------------    sec_num = sec_num+1u;
;**	-----------------------g5:
;** 61	-----------------------    mask *= 2;
;** 59	-----------------------    if ( --L$1 ) goto g3;
;** 63	-----------------------    wr_num_sec = wr_num_sec+sec_num;
;*----------------------------------------------------------------------------*
;*   SOFTWARE PIPELINE INFORMATION
;*
;*      Loop source line                 : 59
;*      Loop opening brace source line   : 59
;*      Loop closing brace source line   : 62
;*      Known Minimum Trip Count         : 8                    
;*      Known Maximum Trip Count         : 8                    
;*      Known Max Trip Count Factor      : 8
;*      Loop Carried Dependency Bound(^) : 13
;*      Unpartitioned Resource Bound     : 2
;*      Partitioned Resource Bound(*)    : 3
;*      Resource Partition:
;*                                A-side   B-side
;*      .L units                     0        0     
;*      .S units                     1        1     
;*      .D units                     0        3*    
;*      .M units                     0        0     
;*      .X cross paths               0        0     
;*      .T address paths             2        1     
;*      Long read paths              0        0     
;*      Long write paths             0        0     
;*      Logical  ops (.LS)           0        0     (.L or .S unit)
;*      Addition ops (.LSD)          1        1     (.L or .S or .D unit)
;*      Bound(.L .S .LS)             1        1     
;*      Bound(.L .S .D .LS .LSD)     1        2     
;*
;*      Searching for software pipeline schedule at ...
;*         ii = 13 Schedule found with 1 iterations in parallel
;*
;*      Register Usage Table:
;*          +-----------------------------------------------------------------+
;*          |AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA|BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB|
;*          |00000000001111111111222222222233|00000000001111111111222222222233|
;*          |01234567890123456789012345678901|01234567890123456789012345678901|
;*          |--------------------------------+--------------------------------|
;*       0: |*                               |     **       **                |
;*       1: |*                               |    ***       **                |
;*       2: |*                               |    ***       **                |
;*       3: |*                               |    ***       **                |
;*       4: |*                               |    ***       **                |
;*       5: |*                               |    ***       **                |
;*       6: |*                               |*    **       **                |
;*       7: |*                               |*    **       **                |
;*       8: |*                               |*    **       **                |
;*       9: |*                               |*    **       **                |
;*      10: |*                               |*    **       **                |
;*      11: |*                               |*    **       **                |
;*      12: |*                               |*   ***       **                |
;*          +-----------------------------------------------------------------+
;*
;*      Done
;*
;*      Loop is interruptible
;*      Collapsed epilog stages     : 0
;*      Collapsed prolog stages     : 0
;*
;*      Minimum safe trip count     : 1
;*----------------------------------------------------------------------------*
;*       SETUP CODE
;*
;*                  SUB             A0,1,A0
;*
;*        SINGLE SCHEDULED ITERATION
;*
;*        C150:
;*   0              LDHU    .D2T2   *+DP(_sec_out_clr),B4 ; |60|  ^ 
;*   1              NOP             4
;*   5              AND     .L2     B6,B4,B0          ; |60|  ^ 
;*   6      [ B0]   LDW     .D2T2   *+SP(4),B5        ; |60|  ^ 
;*   7      [ A0]   BDEC    .S1     C150,A0           ; |59| 
;*   8              NOP             3
;*  11              ADD     .L2     1,B5,B4           ; |60|  ^ 
;*  12      [ B0]   STW     .D2T2   B4,*+SP(4)        ; |60|  ^ 
;*     ||           EXTU    .S2     B6,17,16,B6       ; |61| 
;*  13              ; BRANCHCC OCCURS {C150}          ; |59| 
;*----------------------------------------------------------------------------*
L8:    ; PIPED LOOP PROLOG
;** --------------------------------------------------------------------------*
L9:    ; PIPED LOOP KERNEL
           LDHU    .D2T2   *+DP(_sec_out_clr),B4 ; |60| <0,0>  ^ 
           NOP             4
           AND     .L2     B6,B4,B0          ; |60| <0,5>  ^ 
   [ B0]   LDW     .D2T2   *+SP(4),B5        ; |60| <0,6>  ^ 
   [ A0]   BDEC    .S1     L9,A0             ; |59| <0,7> 
           NOP             3
           ADD     .L2     1,B5,B4           ; |60| <0,11>  ^ 

           EXTU    .S2     B6,17,16,B6       ; |61| <0,12> 
|| [ B0]   STW     .D2T2   B4,*+SP(4)        ; |60| <0,12>  ^ 

;** --------------------------------------------------------------------------*
L10:    ; PIPED LOOP EPILOG
;** --------------------------------------------------------------------------*
;** 78	-----------------------    *(volatile unsigned *)0x68000024u = (unsigned short)((int)sec_out_clr<<4);
;** 79	-----------------------    *(volatile unsigned *)0x68000024u;
;** 82	-----------------------    *(volatile unsigned *)0x68000034u = 4080u;
;** 85	-----------------------    sec_out_clr = 0u;
;** 320	-----------------------    IER = IER|_IRQ_eventTable[4];  // [0]
           LDW     .D2T2   *+DP(_wr_num_sec),B4 ; |63| 
           LDW     .D2T2   *+SP(4),B5        ; |63| 
           NOP             2
           MVKL    .S1     0x68000024,A3     ; |79| 
           MVKH    .S1     0x68000024,A3     ; |79| 
           ADD     .L2     B5,B4,B4          ; |63| 
           STW     .D2T2   B4,*+DP(_wr_num_sec) ; |63| 
           LDHU    .D2T2   *+DP(_sec_out_clr),B5 ; |78| 
           NOP             2
           MVKL    .S2     0x68000024,B4     ; |78| 
           MVKH    .S2     0x68000024,B4     ; |78| 
           EXTU    .S2     B5,20,16,B5       ; |78| 
           STW     .D2T2   B5,*B4            ; |78| 
           LDW     .D1T1   *A3,A3            ; |79| 
           NOP             3
           MVK     .S2     4080,B4           ; |82| 
           MVKL    .S1     0x68000034,A3     ; |82| 
           MVKH    .S1     0x68000034,A3     ; |82| 

           ZERO    .L2     B4                ; |85| 
||         STW     .D1T2   B4,*A3            ; |82| 

           MVC     .S2     IER,B4            ; |320| 
||         STH     .D2T2   B4,*+DP(_sec_out_clr) ; |85| 

           MVKL    .S1     __IRQ_eventTable+16,A3 ; |320| 
           MVKH    .S1     __IRQ_eventTable+16,A3 ; |320| 
           LDW     .D1T1   *A3,A3            ; |320| 
           NOP             4
           OR      .L2X    A3,B4,B4          ; |320| 
           MVC     .S2     B4,IER            ; |320| 
;** --------------------------------------------------------------------------*
L11:    
;**	-----------------------g7:
;** 93	-----------------------    read_done = 1u;
;** 360	-----------------------    CSR = CSR&(K$2 = 0xfffffffeu)|gie&1u;  // [5]
;** 360	-----------------------    return;  // [5]
           MVK     .L1     1,A3              ; |93| 

           MVC     .S2     CSR,B4            ; |360| 
||         STW     .D2T1   A3,*+DP(_read_done) ; |93| 
||         MVK     .L2     0xfffffffe,B5     ; |360| 

           AND     .L2     1,B7,B5           ; |360| 
||         AND     .S2     B5,B4,B4          ; |360| 

           OR      .L2     B5,B4,B4          ; |360| 
           MVC     .S2     B4,CSR            ; |360| 
           LDW     .D2T1   *+SP(12),A0       ; |96| 
           LDW     .D2T1   *+SP(20),A4       ; |96| 
           LDDW    .D2T2   *+SP(32),B7:B6    ; |96| 
           LDW     .D2T1   *+SP(16),A3       ; |96| 

           RET     .S2     IRP               ; |96| 
||         LDDW    .D2T2   *+SP(24),B5:B4    ; |96| 

           LDW     .D2T2   *++SP(40),B0      ; |96| 
           NOP             4
           ; BRANCH OCCURS {IRP}             ; |96| 
;; Inlined function references:
;; [  0] IRQ_enable
;; [  1] IRQ_disable
;; [  2] IRQ_clear
;; [  3] IRQ_globalEnable
;; [  4] IRQ_globalDisable
;; [  5] IRQ_globalRestore
;; [  6] IRQ_resetAll
;; [  9] EDMA_intClear
;; [ 10] EDMA_qdmaConfigArgs
;******************************************************************************
;* UNDEFINED EXTERNAL REFERENCES                                              *
;******************************************************************************
	.global	__IRQ_eventTable
	.global	_read_done
	.global	_ext_int
	.global	_imageptrout
	.global	_wr_num_sec
