#ifndef MEMPORT_HEADER_FILE
#define MEMPORT_HEADER_FILE

//Init memport library
void MemportInit();


// memory port address
#define MEMPORT_ADDR  ((volatile unsigned *)0x68000020)
#define MEMPORT_READY ((volatile unsigned *)0x68000024)
#define MEMPORT_OVF   ((volatile unsigned *)0x6800002C)
#define MEMPORT_DIR   ((volatile unsigned *)0x68000038)
#define MEMPORT_MASK  ((volatile unsigned *)0x68000034)
#define MEMPORT_DATA  ((volatile unsigned *)0x68000030)

//Timer

#define FPGA_TIMER			((volatile unsigned *)0x68000040)	


#define MEMPORT_SECTOR_SIZE	1024// sector size in bytes
#define MEMPORT_SECTOR_COUNT 16 // count of allocable sectors
#define NUM_READ_SEC 4
#define NUM_WRITE_SEC 8

#define EDMA_COMPLETE_CODE 8



//Init memport library
void MemportInit();

#endif


